local lib = LibStub:NewLibrary("LibTalent-1.0", 1)
-- check if already loaded
if not lib then return end

if not lib.frame then
  lib.frame=CreateFrame("Frame")
end


function lib:getTalents()
	lib.talentCache = {}
	local activeConfigID = C_ClassTalents.GetActiveConfigID();
	local configInfo = C_Traits.GetConfigInfo(activeConfigID);
	local treeIDs = configInfo['treeIDs'];
	for i=1,#treeIDs do
		local nodes = C_Traits.GetTreeNodes(treeIDs[i]);
		for k=1,#nodes do
			local talent = C_Traits.GetNodeInfo(activeConfigID, nodes[k])
			if talent.activeEntry then
				local defn = C_Traits.GetDefinitionInfo(C_Traits.GetEntryInfo(activeConfigID, talent.activeEntry.entryID).definitionID);
				local spellName = GetSpellInfo(defn.spellID)
				lib.talentCache[defn.spellID] = talent.activeRank;
				lib.talentCache[spellName] = talent.activeRank;
			end
		end
	end
end

function lib:dumpTalents()
	if not lib.talentCache then
		lib:getTalents()
	end
	for k,v in pairs(lib.talentCache) do
		if type(k) == 'number' then
			print(k.." "..GetSpellInfo(k).." "..v);
		end
	end
end

function lib:clearCache()
	lib.talentCache = nil;
end

function lib:checkTalent(talent)
	if not lib.talentCache then
		lib:getTalents()
	end

	local result = lib.talentCache[talent]
	return result

end

local function OnUpdate()
  -- timing stuff here
end

--TRAIT_CONFIG_UPDATED
lib.frame:RegisterEvent("TRAIT_CONFIG_UPDATED");
lib.frame:SetScript("OnEvent", function() lib:clearCache() end);