if select(2, UnitClass("player")) ~= "MONK" then
    return
end

BrewRyge_Settings = {L={x=-45,y=0}, M={x=0,y=0}, R={x=45,y=0}, XR={x=90,y=0}}
local Breweryge = {}
local barL = CreateFrame("StatusBar", "BrewerygeLBar", UIParent, BackdropTemplateMixin and "BackdropTemplate")
local barM = CreateFrame("StatusBar", "BrewerygeRBar", UIParent, BackdropTemplateMixin and "BackdropTemplate")
local barR = CreateFrame("StatusBar", "BrewerygeRBar", UIParent, BackdropTemplateMixin and "BackdropTemplate")
local barXR = CreateFrame("StatusBar", "BrewerygeXRBar", UIParent, BackdropTemplateMixin and "BackdropTemplate") --Black Ox Brew
local frame = CreateFrame("Frame", "Breweryge", UIParent)
local selectedTalent=0;

local libTalent = LibStub("LibTalent-1.0");

barL:RegisterEvent("ADDON_LOADED");
barL:SetScript("OnEvent", function(self) self:UnregisterEvent("ADDON_LOADED"); Breweryge.Load() end)

barM:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
barM:RegisterEvent("TRAIT_CONFIG_UPDATED")
barM:SetScript("OnEvent", function() Breweryge.changeSpec() end)

barR:SetScript("OnUpdate", function() Breweryge.updateBar() end)

barXR:RegisterEvent("PLAYER_TALENT_UPDATE");
barM:SetScript("OnEvent", function() Breweryge.changeSpec() end)

function Breweryge.Place()
	local a,b,c,x,y = barL:GetPoint()
	local L = BrewRyge_Settings.L
	local M = BrewRyge_Settings.M
	local R = BrewRyge_Settings.R
	local XR = BrewRyge_Settings.XR

	barL:ClearAllPoints();
	barM:ClearAllPoints();
	barR:ClearAllPoints();
	barXR:ClearAllPoints();

	barL:SetPoint(a, b, c, L.x, L.y)
	barM:SetPoint(a, b, c, M.x, M.y)
	barR:SetPoint(a, b, c, R.x, R.y)
	barXR:SetPoint(a, b, c, XR.x, XR.y)
	Breweryge.Place = nil;
end

function Breweryge.updateBar()
	if GetSpecialization() ~=1 then
		return
	end

	if Breweryge.Place then
		Breweryge.Place()
	end

	local selectedBOB = libTalent:checkTalent(115399); --black ox brew

	local charges, maxCharges, start, duration = GetSpellCharges("purifying brew")
	if start==nil then
		return
	end
	local progress = GetTime() - start
	local notMax = 1

	barL:SetMinMaxValues(0, duration)
	barM:SetMinMaxValues(0, duration)
	barR:SetMinMaxValues(0, duration)
	barXR:SetMinMaxValues(0, duration)

	if selectedBOB and selectedBOB > 0 then
		local startBOB, durationBOB, enableBOB = GetSpellCooldown(115399)
		barXR:SetMinMaxValues(0, 120)
		if startBOB==nil or startBOB == 0 then
			barXR:SetValue(120)
			barXR.Text:SetText("120/120")
		else
			barXR:SetValue(GetTime()-tonumber(startBOB))
			barXR.Text:SetText(math.floor(GetTime()-tonumber(startBOB)+0.5).."/120")	
		end
	end

	local startCB, durationCB, enableCB = GetSpellCooldown("celestial brew")
	local spellID, name, iconTexture, selectedLB, available=GetTalentInfo(3,1,1);
	local cbCD = 60
	if selectedLB then cbCD = 48 end
	barR:SetMinMaxValues(0, cbCD)
	if durationCB<2 or startCB==nil or startCB==0 then
		barR:SetValue(cbCD)
		barR.Text:SetText(cbCD.."/"..cbCD)
	else
		barR:SetValue(GetTime()-tonumber(startCB))
		barR.Text:SetText(math.floor(GetTime()-tonumber(startCB)+0.5).."/"..cbCD)	
	end

	if charges==2 then
		notMax = 0;
		barM:SetValue(duration);
		barL:SetValue(duration);
	elseif charges==1 then
		barM:SetValue(progress);
		barL:SetValue(duration);
	elseif charges==0 then
		barM:SetValue(0);
		barL:SetValue(progress);
	end

	local text, max, curr
	max = 2*duration
	curr = charges*duration + progress*notMax
	text = math.floor(curr+0.5).."/"..math.floor(max+0.5)
	barL.Text:SetText(text)
	
end

function Breweryge.Load()
	local L = BrewRyge_Settings.L;
	local M = BrewRyge_Settings.M;
	local R = BrewRyge_Settings.R;
	local XR = BrewRyge_Settings.XR;

	Breweryge.setupBar(barL,L.x,L.y)
	Breweryge.setupBar(barM,M.x,M.y)
	Breweryge.setupBar(barR,R.x,R.y)
	Breweryge.setupBar(barXR,XR.x,XR.y)

	Breweryge.changeSpec()
end

function Breweryge.changeSpec()

	if GetSpecialization()==1 then
		barL:Show()
		barM:Show()
		barR:Show()

		local selectedBOB = libTalent:checkTalent(115399); --black ox brew

		if selectedBOB and selectedBOB > 0 then
			barXR:Show()
		else
			barXR:Hide()
		end
	else
		barL:Hide()
		barM:Hide()
		barR:Hide()
		barXR:Hide()
	end
end

function Breweryge.setupBar(bar,x,y)

	bar:SetWidth(40)
	bar:SetHeight(14)
	bar:SetPoint("CENTER", "UIParent", "CENTER", x,y)
	bar:SetClampedToScreen(true)
	bar:SetScale(1)
	bar:SetBackdrop({
		bgFile = [[Interface\DialogFrame\UI-DialogBox-Background-Dark]],
		tile = true,
		tileSize = 16,
	})
	bar:SetStatusBarTexture([[Interface\TARGETINGFRAME\UI-StatusBar]],"OVERLAY")
	bar:SetOrientation("HORIZONTAL")
	bar:SetStatusBarColor(0,0,0,1)
	bar:SetBackdropColor(0,0,0,0.6)

	if bar==barXR then
		bar:GetStatusBarTexture():SetGradient("HORIZONTAL", CreateColor(102/255, 153/255, 255/255, 1), CreateColor(51/255, 51/255, 204/255, 1))
	elseif bar==barR then
		bar:GetStatusBarTexture():SetGradient("HORIZONTAL", CreateColor(102/255, 255/255, 153/255, 1), CreateColor(51/255, 204/255, 51/255, 1))
	else
	 	bar:GetStatusBarTexture():SetGradient("HORIZONTAL", CreateColor(255/255, 153/255, 102/255, 1), CreateColor(204/255, 51/255, 51/255, 1))
	end
	
	local border = bar:CreateTexture(nil, "BACKGROUND")
	border:SetPoint("CENTER")
	border:SetWidth(bar:GetWidth()+5)
	border:SetHeight(bar:GetHeight()+8)
	border:SetTexture([[Interface\Tooltips\UI-StatusBar-Border]])
	bar.Border = border

	local bartext = bar:CreateFontString(nil, "OVERLAY")
	bar.Text = bartext
	bar.Text:SetFontObject("GameFontHighlightSmall")
	bar.Text:SetPoint("TOP",bar,"TOP",0,-2)
	bar.Text:SetTextColor(1,1,1)
	
	bar:SetMinMaxValues(0,1)
	bar:SetValue(0)
	
	bar:SetMovable(true);
	bar:RegisterForDrag("LeftButton");

	bar:SetScript("OnDragStart", function(self, button) if IsAltKeyDown() then self:StartMoving() end end);
	bar:SetScript("OnDragStop", function(self) self:StopMovingOrSizing(); Breweryge.groupBars(self) end);
	
	bar:EnableMouse(true)
	bar.locked = nil
end

function Breweryge.groupBars(self)
	local a,b,c,x,y = self:GetPoint()
print(x.." "..y)
	local L = BrewRyge_Settings.L;
	local M = BrewRyge_Settings.M;
	local R = BrewRyge_Settings.R;
	local XR = BrewRyge_Settings.XR;
	
	if self==barL then
		barM:ClearAllPoints();
		barR:ClearAllPoints();
		barXR:ClearAllPoints();

		barM:SetPoint(a, b, c, x+45, y)
		barR:SetPoint(a, b, c, x+90, y)
		barXR:SetPoint(a, b, c, x+135, y)

		BrewRyge_Settings = {L={x=x,y=y}, M={x=x+45,y=y}, R={x=x+90,y=y}, XR={x=x+135,y=y}}

	elseif self==barM then
		barL:ClearAllPoints();
		barR:ClearAllPoints();
		barXR:ClearAllPoints();

		barL:SetPoint(a, b, c, x-45, y)
		barR:SetPoint(a, b, c, x+45, y)
		barXR:SetPoint(a, b, c, x+90, y)

		BrewRyge_Settings = {L={x=x-45,y=y}, M={x=x,y=y}, R={x=x+45,y=y}, XR={x=x+90,y=y}}

	elseif self==barR then
		barL:ClearAllPoints();
		barM:ClearAllPoints();
		barXR:ClearAllPoints();

		barL:SetPoint(a, b, c, x-90, y)
		barM:SetPoint(a, b, c, x-45, y)
		barXR:SetPoint(a, b, c, x+45, y)

		BrewRyge_Settings = {L={x=x-90,y=y}, M={x=x-45,y=y}, R={x=x,y=y}, XR={x=x+45,y=y}}

	elseif self==barXR then
		barL:ClearAllPoints();
		barM:ClearAllPoints();
		barR:ClearAllPoints();

		barL:SetPoint(a, b, c, x-135, y)
		barM:SetPoint(a, b, c, x-90, y)
		barR:SetPoint(a, b, c, x-45, y)

		BrewRyge_Settings = {L={x=x-135,y=y}, M={x=x-90,y=y}, R={x=x-45,y=y}, XR={x=x,y=y}}
	end
	
end